        TITLE  Ocean
        ORG    9000h
        CALL   ocean@
        RET
;--------------------------------------------------------------
nosprz    EQU   16  ;    ( +1)
;-------------------------------------------------------------
;      VDP
; [b] - , [c] -  
wrrvdp: LD      A,B       ;  
OUT     (99H),A   ;    VDP
LD      A,C       ;    VDP
OR      80H       ;  7   1
OUT     (99H),A   ;    VDP
RET               ; 
;--------------------------------------------------------------
; -""     ""
block1: DB 0FFh,0FFh,0C0h,0C0h,0C0h,0C0h,080h,0FFh
		DB 91h, 91H, 98h, 98h, 98h, 98h, 96h, 61h
block2: DB 0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
		DB 91h, 91h, 81h, 81h, 81h, 81h, 61h, 61h
block3: DB 0FFh,0FEh,0FCh,0FCh,0FCh,0FCh,0FFh,0FFh
		DB 91h, 96h, 86h, 86h, 86h, 86h, 61h, 61h

;---------------------------------------------------------------
;    
;   " "
DEFS    6
DEFB    30,183,16,0,0,0,90,14
draw:   CALL    EXchg
; --------  
RST     30h
DEFB    0
DEFW    0c0h
LD      HL,draw-1 ;   
                                      ;  13  PSG
LD      a,13      ; -  PSG
LD      e,(HL)    ;  
RST     30h
DEFB    0
DEFW    93h       ;   
DEC     HL        ;   
DEC     a         ; .  PSG
JP      p,draw+1  ;   -1, .
; -------- colOR 4=040
LD      BC,410H   ;   16  VDP
CALL    wrrvdp    ;    4
LD      A,4       ;  
OUT     (9AH),A   ;  4
LD      A,0
OUT     (9AH),A
; -------- colOR 15,1,1
LD      HL,10Fh    ; .  
LD      (0F3EAH),HL;   ..
LD      (0F3E9h),HL
; -------- screen 2,2
LD      HL,0F3E0h  ;   1 VDP
SET     1,(HL)     ;   16x16
RES     0,(HL)     ;  
RST     30h
DEFB    0
DEFW    72H        ; screen 2
; -------- clear the sprites
RST     30h
DEFB    0
DEFW    69H
; --------    
LD      BC,5817H   ;   
                   ;   23
CALL    wrrvdp     ;   23 
PUSH    BC         ;   
                   ;  
CALL    EXchg
; ---------------------
;      (: )
; [HL] -  , [DE] - x,y, [BC] -  Y*X
; ---------------------
LD      (const),DE ; .  X,Y
LD      a,c        ; .   X
LD      (const+2),a
l03:    LD      A,B        ; .  Y
        ADD     A,D        ;  . Y
        LD      D,A        ;   . Y
l04:    PUSH    DE         ;  
        LD      a,(HL)     ;   
                           ; () 
        CALL    EXchg
        POP     DE         ;  
        LD      HL,block1  ;   1 .
        CP      '1'        ;    ?
        JR      z,wrvdm    ;  , 
        LD      HL,block2  ;   2 .
        CP      '2'        ;    ?
        JR      z,wrvdm    ;  , 
        LD      HL,block3  ;   2 .
        CP      '3'        ;    ?
        JR      nz,ewrvdm  ;  , 
wrvdm:  PUSH    DE         ;  
        LD      b,8        ;   
        CALL    ldirvm     ;   VRAM
                           ;   [DE]
        POP     DE         ;  
        PUSH    DE         ;  
        LD      A,D        ; .. .VRAM
        ADD     a,32       ;   
                           ;   
        LD      D,A        ; .   VRAM
        CALL    ldirvm     ; .  
        POP     DE         ;   VRAM
ewrvdm: LD      a,8        ;   
        ADD     A,E        ; .  
                           ;   VRAM
        LD      E,A
        PUSH    DE         ;   VRAM
        CALL    EXchg
        POP     DE         ; ..  
                           ; .  
        INC     HL         ;   
        DEC     c          ;    X
        JR      nz,l04     ;  <> 0,  ..
        LD      DE,(const) ; . .
        LD      a,(const+2);    X
        LD      C,A
        DJNZ    l03        ;   ,  .
        POP     BC         ;  ..
                           ;  23
;--------------------------------------------------------------
;   [b] -   23  VDP
; [c] -  23 ( )
move:   CALL    wrrvdp     ;  
        LD      DE,130H    ; .  
        CALL    time       ; 
        INC     b          ; .  
        JR      nz,move    ;   0,  .
        CALL    wrrvdp     ;  . .
; ----------------------
;  
; ----------------------
ship:  LD      HL,shipdt  ;  
       LD      DE,10D0h   ; Y  X
       LD      BC,2806h   ;  XxY
       PUSH    BC         ;  
       CALL    draw1      ; .   .
       POP     BC         ;  
       LD      DE,30D0h   ;  
       LD      a,71h      ;    
       CALL    draw2      ;  
; ----------------------
;   # Nosprz
; ----------------------
SETspr: LD      a,nosprz   ;  
        RST     30h
        DEFB    0
        DEFW    84h        ;  
                           ; Nosprz
        LD      DE,sprz    ;   
                           ;  
        EX      DE,HL
        LD      b,64       ;   2 
        CALL    ldirvm     ;   VRAM
;   # Nosprz
LD      a,nosprz   ;  
RST     30h
DEFB    0
DEFW    87h        ;  
                   ;  Nosprz
LD      DE,xyspr   ;  
                   ;  
EX      DE,HL
LD      b,8        ;   
JP      ldirvm     ;   VRAM
;-----
shipdt: DEFB    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        DEFB    1,2,6,12,28,78H
        DEFB    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        DEFB    1,2,4,8,16,32,64,248,248,56,68H,68H,78H,216,232
        DEFB    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        DEFB    1,2,4,8,16,48,64,81H,1,3,3,3,3,7,7,232,98H,88H,232,98H,8,252,4
        DEFB    0,0,0,0,0,0,0,0,0
        DEFB    1,1,2,6,15,0,0,80H,80H,0,0,0,0,192,48,6,7,7,7,7,7,7,7
        DEFB    7CH,82H,2,7EH,81H,63,68,87H
        DEFB    0,0,0,0,0,0
        DEFB    80H,192,0,0,0,0,1,0,0,0,12,2,1,0,255,15,2,1,0,0,0,80H,255,255,0
        DEFB    0,7CH,78H,48,32,255,255,1,242,0,0,0,0,224,80H
        DEFB    0,0,0,0,0,0,0,0,0,0
        DEFB    1,6,24,96,0,0,0,0,241,16,27H
        DEFB    0,0,0,0,0
        DEFB    12,81H,240,8,7,0,0,0,0,0,248
        DEFB    0,0,0,0,0
;-----
;      
sprz:   DEFB    137,218,170,139,138,0,127,255,193,192,0,113,170,170,115,34
        DEFB    159,68,68,196,68,0,3,131,255,254,0,145,82,92,210,81
        DEFB    54,85,85,86,85,85,85,246,0,0,0,48,121,255,207,134
        DEFB    117,85,69,69,67,65,69,66,0,0,0,195,231,255,60,24
;-----
;  xy  # Nosprz
xyspr:DEFB    60h,10h,nosprz*4,14,60h,0E0h,(nosprz+1)*4,14
;-----------------------------------------------
;  VRAM 
; [HL] - , [DE] - , [BC] - ,y
draw1:     PUSH    DE         ;   VRAM
           CALL    ldirvm     ;  
           POP     DE         ;   VRAM
           INC     D          ;  
           DEC     C          ;   ,
           JR      NZ,draw1   ;  
           RET                ;  
;-----------------------------------------------
;  VRAM const
; [DE] - , [BC] - x,y, [a] - const
draw2:  PUSH    DE         ;  
        PUSH    BC         ; VRAM  
        CALL    fillvm     ;  
        POP     BC         ;  
        POP     DE         ;   VRAM
        INC     D          ;  
        DEC     C          ;  Y=Y-1
        JR      NZ,draw2   ;   ,
        RET                ; 
;-----------------------------------------------
;  VRAM 255
fvmFF:    LD      A,255
;-----------------------------------------------
;  VRAM const [a], len [b], adr [DE]
fillvm: CALL    wrvram     ;    VRAM
        INC     DE
        DJNZ    $-4        ; ,  
        RET
;-----------------------------------------------
;  [a]  VRAM [DE] - adr
wrvram: EX      DE,HL
        RST     30h
        DEFB    0
        DEFW    4Dh        ;  VRAM
        EX      DE,HL      ; ( msx-2)
        RET
;-----------------------------------------------
;  RAM  VRAM [HL] source, [DE] DEst, [b] length
ldirvm: PUSH    BC         ;   
        LD      A,E        ;   
        OUT     (99h),a    ;  VRAM
        LD      A,D        ;   
        OR      40h        ;  6   1
        OUT     (99h),a
        LD      c,98h      ;    VDP
        OTIR               ;  
        POP     BC         ;   
        RET
;===============================================
;  ''
okean:  DEFB  ' 1223  13  13 1223 13  13 13  13'
        DEFB  '13  13 13 13  13   13  13 13  13'
        DEFB  '13  13 1223   13   122223 13  13'
        DEFB  '13  13 123    123  13  13 122223'
        DEFB  '13  13 1223   13   13  13 13  13'
        DEFB  '13  13 13 13  13    1223  13  13'
        DEFB  ' 1223  13  13 1223   13   13  13'
;------
pbyok:  DEFB    247,211,197,211,207,192,218,206,217,202,32,208,201,207,206
        DEFB    197,210,211,203,201,202,32,204,193,199,197,210,216,32,227,235
        DEFB    32,247,236,235,243,237,0
cfib:   DEFB    '(c) ',199,210,213,208,208,193,' F&B, ',247,240,236,' "'
        DEFB    239,203,197,193,206,'", 1988',0
emar:   DEFB    226,213,200,212,193,32,229,205,193,210,0
year:   DEFB    '1988',0
;---------------------------------------------
ocean@:   ;  
LD      HL,okean   ;  
LD      BC,0720h   ;  YxX
LD      DE,0200h   ;   VRAM
CALL    draw       ;  
LD      a,0Fh      ;  15
LD      DE,pbyOK   ;  ' ...'
LD      HL,1208h   ;   
CALL    print2
LD      HL,61A2h   ;   
LD      DE,emar    ; ' '
LD      A,0Fh
CALL    print2
LD      HL,73ACh
LD      DE,year    ;  '1988'
LD      A,0Fh
CALL    print2
LD      DE,3718h   ;   
                   ;  
LD      B,0D0h     ;  
LD      A,0E4h     ;  4 ()
CALL    fillvm
LD      A,14       ;   14
LD      HL,1CB8h   ;   
LD      DE,cfib    ;   '(c)
                   ;  F&B...'
JP      print2     ;    
                   ; 
;-----------------------------------------------
;      SCREEN 2
; [HL] - x,y, [DE] -  , [a] - 
print2:ld      (0F3E9h),a ;   [a]
       PUSH    DE         ;   
       EX      DE,HL      ;   DE 
       LD      HL,0FCB9h  ;   
                          ; 
       LD      (HL),E     ;   Y
       DEC     HL         ;   
                          ;  X
       DEC     HL
       LD      (HL),D     ;   X
       POP     DE         ;   
l08:   LD      A,(DE)     ;   
                          ; 
       OR      A          ; :  ?
       RET     Z          ;  ,  
       RST     30h
       DEFB    0
       DEFW    8Dh        ;   
       DEC     (HL)       ;  X = 6,  8
                          ; (  )
       DEC     (HL)
       INC     DE         ;  
       JR      l08        ; 
;-----------------------------------------------
;    
;   TIME+3, [DE] - - 
;   TIME, -  = FFFF
time:   DEC     DE         ; ,
        LD      A,D        ;  DE <> 0
        OR      E
        JR      NZ,time    ;  
        RET                ;  
;-----------------------------------------------
EXchg:  PUSH    AF
        PUSH    HL
        LD      HL,EXxd
        LD      A,(HL)
        LD      (HL),B
        LD      B,A
        INC     HL
        LD      A,(HL)
        LD      (HL),C
        LD      C,A
        INC     HL
        LD      A,(HL)
        LD      (HL),D
        LD      D,A
        INC     HL
        LD      A,(HL)
        LD      (HL),E
        LD      E,A
        POP     HL
        PUSH    DE
        LD      DE,(EXxd+4)
        LD      (EXxd+4),HL
        EX      DE,HL
        POP     DE
        POP     AF
        RET
 ;-----------------------------------------------
const:  DEFS    4
EXxd:   DEFS    6
                END
